using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace XnaDevRu.Bullet.Dynamics
{
	public interface IVehicleRaycaster
	{
		object CastRay(Vector3 from, Vector3 to, out VehicleRaycasterResult result);
	}

	public class VehicleRaycasterResult
	{
		private Single _distFraction;
		private Vector3 _hitNormalInWorld;
		private Vector3 _hitPointInWorld;

		public VehicleRaycasterResult()
		{
			_distFraction = -1;
		}

		public float DistFraction { get { return _distFraction; } set { _distFraction = value; } }
		public Vector3 HitNormalInWorld { get { return _hitNormalInWorld; } set { _hitNormalInWorld = value; } }
		public Vector3 HitPointInWorld { get { return _hitPointInWorld; } set { _hitPointInWorld = value; } }
	}
}
