using System;
using System.Collections.Generic;
using System.Text;

namespace XnaDevRu.Bullet
{
	/// Dispatcher uses these types
	/// IMPORTANT NOTE:The types are ordered polyhedral, implicit convex and concave
	/// to facilitate type checking
	public enum BroadphaseNativeTypes
	{
		// polyhedral convex shapes
		Box,
		Triangle,
		Tetrahedral,
		ConvexTriangleMesh,
		ConvexHull,
		//implicit convex shapes
		ImplicitConvexShapes,
		Sphere,
		MultiSphere,
		Cone,
		Convex,
		Cylinder,
		MinkowskiSum,
		MinkowskiDifference,
		//concave shapes
		ConcaveShapesStart,
		//keep all the convex shapetype below here, for the check IsConvexShape in broadphase proxy!
		TriangleMesh,
		//used for demo integration FAST/Swift collision library and Bullet
		FastConcaveMesh,
		//terrain
		Terrain,
		//Used for GIMPACT Trimesh integration
		Gimpact,

		Empty,
		StaticPlane,
		ConcaveShapesEnd,

		Compound,

		MaxBroadphaseCollisionTypes,
	}
}
