using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace XnaDevRu.Bullet
{
	public enum DebugDrawModes : int
	{
		NoDebug = 0,
		DrawWireframe = 1,
		DrawAabb = 2,
		DrawFeaturesText = 4,
		DrawContactPoints = 8,
		NoDeactivation = 16,
		NoHelpText = 32,
		DrawText = 64,
		ProfileTimings = 128,
		EnableSatComparison = 256,
		DisableBulletLcp = 512,
		EnableCcd = 1024,
		MaxDebugDrawMode
	}

    public interface IDebugDraw
    {
        void DrawLine(Vector3 from, Vector3 to, Vector3 color);

        void DrawContactPoint(
            Vector3 pointOnB,
            Vector3 normalOnB,
            float distance,
            int lifeTime,
            Vector3 color
        );

		DebugDrawModes DebugMode { get; set; }
    }
}