using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace XnaDevRu.Bullet
{
	/// <summary>
	/// IConvexPenetrationDepthSolver provides an interface for penetration depth calculation.
	/// </summary>
	public interface IConvexPenetrationDepthSolver
	{
		bool CalculatePenetrationDepth(
			ISimplexSolver simplexSolver,
			ConvexShape convexA, ConvexShape convexB,
			Matrix transformA, Matrix transformB,
			Vector3 vector, out Vector3 ptrA, out Vector3 ptrB,
			IDebugDraw debugDraw//, StackAlloc stackAlloc
		);
	}
}
